%macro oposmast;

options &mprint &source &notes;
%let table=hcmdata.openpos;

options metarepository="&HRRepos";
%LibConOp(sesetl_sasLibRef=HCMDATA,
         sesetl_ChkDepRepos=Y
         ) ;
proc sql;
    connect to &sesetl_EngineType as PASSTHRU
               (&sesetl_BestLogin &sesetl_ConnectionOptions );
       execute(drop table if exists oposmast
               ) by PASSTHRU;
    disconnect from PASSTHRU;
QUIT;

/* make sure work library has no current copies of the needed work datasets */
%deltable(tables=keys openpos posmast posmast1 posmast2 posmast3);


%let basekeys=&oposkeys;
%let joinkeys=position_cd job_cd internal_org_id;

/* create a working copy of OPENPOS */
proc sort data=&table out=openpos;
  by &basekeys;
  where open_dt le "&bldctoff"d;
run;

/* build the initial keys data set */
%joinkeys(basetabl=openpos,basekeys=&basekeys,joinkeys=&joinkeys,init=Y);

/* join in position information */
%hrjoin(table=posmast1,base=keys,basejvar=position_cd,
        join=hcmdata.pos,joinjvar=position_cd,
        basekey=&basekeys,basedate=open_dt,joindate=VALID_FROM_DT,dropvars=&posm  _lastrec,
        eedtevar=VALID_TO_DT);

/* see if we need to pick up additional keys from pos */
%joinkeys(basetabl=posmast1,basekeys=&basekeys,joinkeys=&joinkeys);

/* join in job information */
%hrjoin(table=posmast2,base=keys,basejvar=job_cd,
        join=hcmdata.jobs,joinjvar=job_cd,
        basekey=&basekeys,basedate=open_dt,joindate=VALID_FROM_DT,dropvars=&jobsm  _lastrec,
        eedtevar=VALID_TO_DT);


/* see if we need to pick up additional keys from jobs */
%joinkeys(basetabl=posmast2,basekeys=&basekeys,joinkeys=&joinkeys);


/* join in hierarchy information */
data keyshr(rename=(internal_org_id=intorg));
      set keys;run;
%grplevs(baseds=keyshr,grplevds=hcmdata.wrkgrp,basedate=open_dt,eedtevar=,
         hiername=hiermax,rptgrp=intorg,prntgrp=parent_intorg,
         outds=rptgrphr,joindate=VALID_FROM_DT,root=&default_hier,mgrname=MANAGER_NAME);
data posmast3;set rptgrphr(rename=(intorg=internal_org_id)drop=grpdesc hierarchy_cd);run;

data oposmast;
  merge
    posmast3
    posmast2
    posmast1
    openpos(in=s)
  ;
  by &basekeys;
  if s;

  opentime=close_dt-open_dt;

  %YRQTRMON(date=open_dt,year=year,qtr=qtr,month=month);

  /* drop any additional variables */
  %DROPVAR(dropvar=oposmstv);
run;

/* set _lastrec and place into final sorted order and location */
proc sort data=oposmast;by position_cd descending open_dt;
data oposmast;
 set oposmast;by position_cd descending open_dt;
 If first.position_cd then _lastrec='Y';
 else _lastrec='N';
 proc sort data=oposmast out=hcmdata.OPOSMAST;by &opsmsort;
run;

/* clean up */
%deltable(tables=keys openpos posmast1 posmast2 posmast3 oposmast keyshr rptgrphr);

%regrdata(sesetl_altETLStudioTreeNm=SAS Data Integration Studio Custom Tree,
          sesetl_altEtlStudioGroupNm=Data Integration Studio Groups,
          sesetl_sasLibrary=hcmdata,sesetl_physicalTable=OPOSMAST);

%mend;
