%macro salhist;

options &mprint &source &notes;

options metarepository="&HRRepos";
%LibConOp(sesetl_sasLibRef=HCMDATA,
         sesetl_ChkDepRepos=Y
         ) ;
proc sql;
    connect to &sesetl_EngineType as PASSTHRU
               (&sesetl_BestLogin &sesetl_ConnectionOptions );
       execute(drop table if exists salhist
               ) by PASSTHRU;
    disconnect from PASSTHRU;
QUIT;

%let table=hcmdata.acthmast;

/* CHANGE ACTION_DT TO EFFECTIVE DATE? */

data hcmdata.SALHIST;
  set &table;
  by employee_id;

  if first.employee_id then do;
    old_est=.;
    old_mnth=.;
    old_sal=.;
    old_cvar=.;
  end;

  %salacts;

  /* calculate the change statistics */
  if annual_salary ne . and old_est ne . then chngest=annual_salary-old_est;
  if monthly_salary ne . and old_mnth ne . then chngmnth=monthly_salary-old_mnth;
  if hourly_salary ne . and old_sal ne . then chngsal=hourly_salary-old_sal;

  /* calculate the change percentage */
  if &salcvar ne . and old_cvar not in (0,.) then
     chngpct=(&salcvar-old_cvar)/old_cvar;

  /* output the currently held record */
  output;

  /* set the current info as the old info before leaving the record */
  old_est=annual_salary;
  old_mnth=monthly_salary;
  old_sal=hourly_salary;
  old_cvar=&salcvar;

  retain old_est old_mnth old_sal old_cvar;
  drop old_cvar;

  /* drop any additional variables */
  %DROPVAR(dropvar=salhistv);

run;

%regrdata(sesetl_altETLStudioTreeNm=SAS Data Integration Studio Custom Tree,
          sesetl_altEtlStudioGroupNm=Data Integration Studio Groups,
          sesetl_sasLibrary=hcmdata,sesetl_physicalTable=SALHIST);

%mend;
