%macro terminat;

options &mprint &source &notes;

%let table=hcmdata.acthmast;

options metarepository="&HRRepos";
%LibConOp(sesetl_sasLibRef=HCMDATA,
         sesetl_ChkDepRepos=Y
         ) ;
proc sql;
    connect to &sesetl_EngineType as PASSTHRU
               (&sesetl_BestLogin &sesetl_ConnectionOptions );
       execute(drop table if exists termmast
               ) by PASSTHRU;
    disconnect from PASSTHRU;
QUIT;

%local keepvars i;
  %do i=1 %to &number_of_hiers;
    %let hier=%scan(&hiers, &i);
    %let hiername_temp = hiermax;
    %if &i > 1 %then %do;
       %let hiername_temp=&&hiername_temp%eval(&i-1);
        %put hiername_temp=&hiername_temp;
    %end;
    %else %do;
       %let hiername_temp=&&hiername_temp;
    %end;
        %let keepvars=&keepvars
    %classgen(prefix=&hier,maxvar=&hiername_temp);
  %end;
     %let keepvars=&keepvars
  ;

/* check the existence of the variables */
%varshere(dsname=hcmdata.ACTHMAST,vars=%quote(
                           &termcubev
                           &termvars action_dt
                           &keepvars
                           %classgen(prefix=MNMLEV)
                           hourly_salary annual_salary monthly_salary
                           action_type_cd employee_action_reason_cd hire_dt
                           service_start_dt service_years employee_name));

data hcmdata.TERMMAST;
  set &table(keep=&here
              where=(put(action_type_cd,$iaction.) in ('ITERM' 'VTERM'))
              );
   by employee_id;
   if last.employee_id;
   length yearmon $7;
   yearmon=trim(left(put(year,4.)))!!'M'!!left(put(month,z2.));
   _lastrec='Y';

  /* drop any additional variables */
  %DROPVAR(dropvar=termnatv);
run;

%regrdata(sesetl_altETLStudioTreeNm=SAS Data Integration Studio Custom Tree,
          sesetl_altEtlStudioGroupNm=Data Integration Studio Groups,
          sesetl_sasLibrary=hcmdata,sesetl_physicalTable=TERMMAST);

%mend;
