%macro tip;

options &mprint &source &notes;

%let table=hcmdata.acthmast;

options metarepository="&HRRepos";
%LibConOp(sesetl_sasLibRef=HCMDATA,
         sesetl_ChkDepRepos=Y
         ) ;
proc sql;
    connect to &sesetl_EngineType as PASSTHRU
               (&sesetl_BestLogin &sesetl_ConnectionOptions );
       execute(drop table if exists tip
               ) by PASSTHRU;
    disconnect from PASSTHRU;
QUIT;

%local keepvars i;
  %do i=1 %to &number_of_hiers;
    %let hier=%scan(&hiers, &i);
    %let hiername_temp = hiermax;
    %if &i > 1 %then %do;
       %let hiername_temp=&&hiername_temp%eval(&i-1);
        %end;
    %else %do;
       %let hiername_temp=&&hiername_temp;
    %end;
        %let keepvars=&keepvars
    %classgen(prefix=&hier,maxvar=&hiername_temp);
  %end;
     %let keepvars=&keepvars
    &tipvars &hiers;

%deltable(tables=acttemp);

/* Build a data set from acthmast that has records for anyone leaving a position */
/* Leaving a position is defined as having their jobcode change. */
/* Add current position to output SDR 6/5/00                  */
/* Change jobcode to &tipvar      SDR 7/18/00                 */

proc sort data=&table(keep=&keepvars employee_id &tipvar action_dt action_type_cd valid_to_dt
               permanence_cd where=(put(permanence_cd,$iregtmp.) ne 'T'
               )) out=acttemp;
  by employee_id action_dt;
run;


data hcmdata.TIP(%idxcreat(&tipindx)
                    rename=(enddt=VALID_TO_DT begindt=VALID_FROM_DT));
  set acttemp;
  by employee_id &tipvar notsorted;
  retain frstflag begindt;

  if first.&tipvar then prveedte=.;

  /* first record for a job */
  if first.&tipvar or frstflag then begindt=action_dt;

  /* employee left a job but still in company */
  if last.&tipvar and not last.employee_id then enddt=valid_to_dt;

  /* current active record */
  if last.employee_id and put(action_type_cd,$iaction.) not in ('ITERM','VTERM') then
  enddt="&bldctoff"d;

  /* left the company */
  if put(action_type_cd,$iaction.) in ('VTERM', 'ITERM') then do;
    enddt=prveedte;
    frstflag=1;
  end;
  else frstflag=0;

  prveedte=valid_to_dt;
  retain prveedte;

  if enddt ne .;

  /* tipcalc macro to calculate time units */
  %TIPCALC

  format begindt enddt mmddyy10.;
  keep &keepvars employee_id enddt begindt days months years;
run;
%deltable(tables=acttemp);

%regrdata(sesetl_altETLStudioTreeNm=SAS Data Integration Studio Custom Tree,
          sesetl_altEtlStudioGroupNm=Data Integration Studio Groups,
          sesetl_sasLibrary=hcmdata,sesetl_physicalTable=TIP);

%mend;
