/*-- Copyright (c) 2003 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --*/
/*
 * register_stagedds_mdata.sas
 * Version 9.1S
 * Creates and registers staging tables for the Detailed Data Store using
 * defined DDL.
 *
 * Copyright (c) 2003, 2004 by SAS Institute Inc., Cary, NC 27513
 */

options metarepository="&DdsRepos";
%let iomserver=&sesetl_serverContext;

/* register dds stage tables */
%bldLibNm(sesetl_sasLibRef=STAGEDDS,
                 sesetl_OMRSASLibraryObjName=,
                 sesetl_ChkDepRepos=Y,
                 sesetl_useMLE=N
                ) ;
%checkLib(sesetl_libref=StageDDS) ;

 %let ddstreename=Staging Tables;
 %let stgprefix=STAGE_;
 %let libname=STAGEDDS;
 %regdds;



/*
 * Register SAS Supplied Tables
 */
%bldLibNm(sesetl_sasLibRef=SAS_SUP,
                 sesetl_OMRSASLibraryObjName=,
                 sesetl_ChkDepRepos=Y,
                 sesetl_useMLE=N
                ) ;

%checkLib(sesetl_libref=SAS_SUP) ;


%let sesetl_sasLibrary = SAS_SUP ;
%let sesetl_registerTables = work._registerTables ;
%let sesetl_version = DDS SAS Supplied Model - v1.2 ;
%let sesetl_treeName = Staging Tables ;
%let sesetl_validTreeTypes = D:Dimension Tables @ R:Reference Tables @ F:Fact Tables ;
%let sesetl_altETLStudioTreeNm=SAS Data Integration Studio Custom Tree;
%let sesetl_altEtlStudioGroupNm=Data Integration Studio Groups;
%let sesetl_security = Y ;


data &sesetl_registerTables ;
  length sasTableName    $255 ;
  length omrObjTableName $255 ;
  length treeType        $1 ;

  sasTableName    = "SAS_RETAINED_EARN_ROLL_FWD_METH" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

  sasTableName    = "SAS_COUNTRY" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

  sasTableName    = "SAS_CURRENCY" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

  sasTableName    = "SAS_CURRENCY_EXCH_RATE_TYPE" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

  sasTableName    = "SAS_DIMENSION_TYPE" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

  sasTableName    = "SAS_GL_ACCOUNT_TYPE" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

  sasTableName    = "SAS_LANGUAGE" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

  sasTableName    = "SAS_MEASURE" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

  sasTableName    = "SAS_PERIOD_TYPE" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

  sasTableName    = "SAS_SOURCE_SYSTEM" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;
  
  sasTableName    = "SAS_GL_NORMAL_BAL" ;
  omrObjTableName = sasTableName ;
  treeType        = "R" ;
  output ;

run ;


proc display c=sashelp.regdata.RegisterSASDataSets.scl;
run;


