/* 
   **********************************************************************
   * * * * This program will only be executed for .2 Solutions.   * * * *
   **********************************************************************

   After running DI Studio 3.4 metadata update from SMC, the TreeType for 
   Tree='Metric Tables' (if existing) will be changed from 'MetricTables' to 'BIP Folder'
   This is a requirement for BI Manager.
   If hotfix has been applied for DI Studio update, the update will also create an 
   Extension object (@Name='TreeType', @Value='MetricTables') to hold the value
   that was previously stored in attribute TreeType.
   
   For .2 TreeType will have to be set back to 'MetricTables'.
*/

options notes source source2;  
options metarepository="&SlnRepos";

data _null_;
  length _search $256;
  length _treetype $256;
  length id $17;
  id = "";
  _treetype = "";
  _change = 0;

  _search = "omsobj:SoftwareComponent?SoftwareComponent"
             !! "[@Name='Solutions Common' and @SpecVersion='1.2']";
  rc=metadata_resolve(_search, "", id); 

  if id eq " " then do;
    put 'NOTE: Installed code version is not 1.2 - No metadata changes made.';
    stop;
  end;  

  id = "";
  _search = "omsobj:Tree?Tree[@Name='Metric Tables']"
            !! "[Extensions/Extension[@Name='TreeType' and @Value='MetricTables']]";
  rc=metadata_resolve(_search, "", id); 

  if id ne "" then do;
    rc=metadata_getattr(id, "TreeType", _treetype);
    if strip(_treetype) ne 'MetricTables' then do;
      _change = 1;
      rc=metadata_setattr(id, "TreeType", "MetricTables");
      put 'NOTE: Metadata ' id= '- TreeType attribute set to "MetricTables"';
    end;  
  end;
  else do;
    id = "";
    _search = "omsobj:Tree?Tree[@Name='Metric Tables' and @TreeType='BIP Folder']";
    rc=metadata_resolve(_search, "", id); 

    if id ne "" then do;
       _change = 1;
       rc=metadata_setattr(id, "TreeType", "MetricTables");
       put 'NOTE: Metadata ' id= '- TreeType attribute set to "MetricTables"';
    end;
  end;  

  if _change eq 0 then do;
    put 'NOTE: Metadata OK - no changes made.';
  end;
run;
