/*+------------------------------------------------------------------------+
  | Copyright (c) 2003, 2004 by SAS Institute Inc., Cary, NC 27513
  | Name:     SPM Registry for Tables and Views
  | Product:  SAS Strategic Performance Management
  | Language: SAS
  | Author:    
  | Purpose:
  |
  | Register SPM Data Mart tables and all SAS tables/views used within  
  | SAS/ETL Studio
  | 
  +------------------------------------------------------------------------+*/
%global PmSchem;

%macro regSPMtb(libref=,                                                                                                                                                              
                tablename=
                );
              
            
   %nrstr(%regRdata) (
             sesetl_databaseSchema=&PmSchem,
             sesetl_sasLibrary=&libref,
             sesetl_physicalTable=&tablename,
             sesetl_Tree=R,
             sesetl_Version=PM SAS Supplied Model - v1.0,
             sesetl_altETLStudioTreeNm=SAS Data Integration Studio Custom Tree,
             sesetl_altEtlStudioGroupNm=Data Integration Studio Groups,
             sesetl_TreeName=Data Mart,
             sesetl_ValidTreeTypes=D:Dimension Tables @ R:Reference Tables @ 
                                   F:Fact Tables,
             sesetl_cacheGroupNm=,
             sesetl_propertySetNm=DBMSNames,
             sesetl_ChkDepRepos=Y,
             sesetl_summaryRoleDs=,
       sesetl_OMRTableObjName=,
       sesetl_runscd=,
       sesetl_businesskey=,
       sesetl_surrogatekey=,
             sesetl_security=
            ) ;
        
 
%mend ; 

/*+------------------------------------------------------------------------+
  | Allocate SPMDs library 
  +------------------------------------------------------------------------+*/ 
options  metarepository="&pmrepos";

%bldLibNm(sesetl_sasLibRef=SPMDS,
          sesetl_OMRSASLibraryObjName=,
          sesetl_ChkDepRepos=Y,
          sesetl_useMLE=N,
          sesetl_continue=Y
         ) ;
         
%checkLib(sesetl_libref=SPMDS) ;
  
/*+------------------------------------------------------------------------+
  | Select PM Data Mart tables for registry in OMR
  +------------------------------------------------------------------------+*/       
proc sql;
    create table T1Names as
        select memname from Dictionary.tables
        where libname='SPMDS'
        /*  The production version should enumerate the SPM table names,
            by removing this comment
            AND memname IN (
            'alert'
            'alertoutputmedia'
            'attribute'
            'columndef'
            'columninfo'
            'culture'
            'diagram'
            'diagramelementtype'
            'diagramgroupentry'
            'diagramlink'
            'diagramnode'
            'element'
            'elementattributekey'
            'elementattributetext'
            'elementcolumn'
            'elementcolumndisplay'
            'elementtype'
            'emailrecipient'
            'font'
            'image'
            'intrval'
            'label'
            'measure'
            'measurevalue'
            'outputmedia'
            'period'
            'project'
            'range'
            'scorecard'
            'scorecarddef'
            'shape'
            'template'
            'usercellthreshold'
            'usercolumnthreshold'
            'variable'
            'view'
            'viewdef'
           )  */  
        ;
              
quit; 

/*+------------------------------------------------------------------------+
  | Register Tables
  +------------------------------------------------------------------------+*/ 
data _null_;
    set T1Names;
    call execute('%regSPMtb(libref=SPMDS, tablename=' || memname || ')' );    
run;

/*+------------------------------------------------------------------------+
  | Generate and register all other SAS tables/views associated to SPM  
  +------------------------------------------------------------------------+*/ 
%spmetl;